%define	desktop_vendor startcom
%define desktop_utils  %(test -x /usr/bin/desktop-file-install && echo "yes")

# do we build the keyboard interface to the ardour engine?
%define build_ksi 0
%define build_vst 0

Summary:       Multichannel Digital Audio Workstation
Name:          ardour
Version:       0.99.2
Release:       1%{?dist}
Source:        ardour-%{version}.tar.bz2
Source1:       ardour.png
Patch0:        ardour-0.9beta11.2-cerrno.patch
Patch1:        ardour-0.9beta20-templates.patch
URL:           http://ardour.sourceforge.net
License:       GPL
Group:         Applications/Multimedia
BuildRoot:     %{_tmppath}/%{name}-%{version}-root

BuildRequires: gcc-c++, scons, pkgconfig, bison, byacc, flex 
BuildRequires: automake, autoconf, libtool
BuildRequires: gtk+-devel, libart_lgpl-devel
BuildRequires: alsa-lib-devel, jack-audio-connection-kit-devel >= 0.97.3
BuildRequires: gettext >= 0.11.5
BuildRequires: libsndfile-devel >= 1.0.0
BuildRequires: libsamplerate-devel >= 0.0.13
BuildRequires: liblrdf-devel >= 0.3.1
BuildRequires: libxml2-devel >= 2.5.0
%{?fc2:BuildRequires: curl-devel}
%{?fc1:BuildRequires: curl-devel, glib2-devel, krb5-devel, openssl-devel}
%{?rh9:BuildRequires: curl-devel, glib2-devel, krb5-devel, openssl-devel}

# uncomment if building a cvs version
# %if "%{cvsdate}" != "%{nil}"
# BuildRequires: autoconf >= 2.52
# %if "%{distro}" == "2" || "%{distro}" == "1"
# BuildRequires: automake >= 1.7
# %else
# BuildRequires: automake17
# %endif
# %endif

%description
Ardour is a multichannel hard disk recorder (HDR) and digital audio
workstation (DAW). It is capable of simultaneous recording 24 or more
channels of 32 bit audio at 48kHz. Ardour is intended to function as a
"professional" HDR system, replacing dedicated hardware solutions such
as the Mackie HDR, the Tascam 2424 and more traditional tape systems
like the Alesis ADAT series. It is also intended to provide the same
or better functionality as software systems such as ProTools,
Samplitude, Logic Audio, Nuendo and Cubase VST (we acknowledge these
and all other names as trademarks of their respective owners). It
supports MIDI Machine Control, and so can be controlled from any MMC
controller, such as the Mackie Digital 8 Bus mixer and many other
modern digital mixers.

%package ksi
Summary:       Curses-based interface to the Ardour library
Version:       %{version}
Group:         Applications/Multimedia

%description ksi
ardour/ksi is a curses-based interface to the Ardour engine that
allows you to use your ALSA-support audio interface as a powerful,
real-time multichannel mixer. ardour/ksi uses a key assignment
designed by Frank Carmickle that is incredibly ergonomic and easy to
use. It uses the keyboard to provide 10 channels worth of control at a
time, with other channels just a keypress away. ardour/ksi allows the
addition, editing and removal of LADPSA plugins to each channel, as
well as the usual mute/solo/pan/gain controls. 

In addition there is a utility called "remote_kbd". this
provides most of the functionality associated with X, but provides it
for programs like ardour/ksi that uses curses AND use the keyboard in
the kernel's "raw" mode. all existing TCP/IP-based remote protocols
(that I can think of) except X are based on transmitting characters
read from various inputs; in ardour/ksi we want to know about Ctrl-i
as distinct from TAB, for example. with the standard keyboard mode,
there is no way to distinguish between these two things. Since neither
telnet, nor rlogin nor ssh or the rest will transmit raw keycode
information in a useful way, remote_kbd provides a small program (250
lines in the source) that puts the keyboard in raw mode, transmits any
keycodes to a client connected via a socket, and forwards any data
read from the client to stdout.

This allows ardour/ksi to be run on a machine with, for example, a
low-latency kernel installed for high performance, but have the
display be on a machine with the SpeakUp system for screen readers.
If screen readers could handle X, this would not have been necessary.

%prep
%setup -q -n ardour-%{version}
%patch0 -p1

%build
scons %{?_smp_mflags} PREFIX=%{_prefix} \
      NOARCH="1" ARCH="$RPM_OPT_FLAGS" \
%if "%{build_ksi}" == "1"
      KSI="yes" \
%endif
%if "%{build_vst}" == "1"
      VST="yes"
%endif

# ardour installs the static libardour library, we don't need it
%{__rm} -f %{buildroot}%{_libdir}/ardour/libardour*

%install
%{__rm} -rf %{buildroot}
%{__mkdir} -p %{buildroot}
scons DESTDIR=%{buildroot}  NOARCH="1" ARCH="$RPM_OPT_FLAGS" install

# install the icon
%{__mkdir} -p %{buildroot}/%{_datadir}/pixmaps/
%{__install} -m 644 %{SOURCE1} %{buildroot}/%{_datadir}/pixmaps/

# install the desktop entry
cat << EOF > %{desktop_vendor}-%{name}.desktop
[Desktop Entry]
Name=Ardour
Comment=Ardour Digital Audio Workstation
Icon=ardour.png
Exec=%{_bindir}/ardour
Terminal=false
Type=Application
EOF
%if "%{desktop_utils}" == "yes"
  %{__mkdir} -p %{buildroot}%{_datadir}/applications
  desktop-file-install --vendor %{desktop_vendor} \
    --dir %{buildroot}%{_datadir}/applications \
    --add-category X-StartCom-Base                 \
    --add-category AudioVideo                     \
    --add-category Application                    \
    %{desktop_vendor}-%{name}.desktop
%else
  %{__install} -d %{buildroot}%{_sysconfdir}/X11/applnk/Multimedia
  %{__install} %{desktop_vendor}-%{name}.desktop %{buildroot}%{_sysconfdir}/X11/applnk/Multimedia/
%endif

# rename the resulting binary in 7.3... sigh...
if [ -e "%{buildroot}%{_bindir}/i386-redhat-linux-ardour" ] ; then
  %{__mv} %{buildroot}%{_bindir}/i386-redhat-linux-ardour %{buildroot}%{_bindir}/ardour
fi

%clean
%{__rm} -rf %{buildroot}

%files
%defattr(-,root,root)
%doc README COPYING DOCUMENTATION
%{_bindir}/ardour
%{_datadir}/ardour
%config /etc/ardour/*.rc
# %{_mandir}/man1/ardour*
# %{_mandir}/*/man1/ardour*
%{_datadir}/pixmaps/ardour*
%if "%{desktop_utils}" == "yes"
%{_datadir}/applications/*%{name}.desktop
%else
%{_sysconfdir}/X11/applnk/Multimedia/%{desktop_vendor}-%{name}.desktop
%endif
%{_datadir}/locale/*/*/*

%if "%{build_ksi}" == "1"
%files ksi
%defattr(-,root,root)
%{_bindir}/ksi
%{_bindir}/remote_kbd
%endif

%changelog
* Fri Apr 21 2006 Eddy Nigg <eddy_nigg@startcom.org>
- Rebuild for StartCom Linux 5.0.x
- Upgrade to version 0.99.2

* Thu Jun 16 2005 Eddy Nigg <eddy_nigg@startcom.org>
- rebuild and update for StartCom Linux 4.0.x
